// RCS Private Heading
/***************************************************************************
   $Name: JavaConverter $

   $Author: dmeline $
   $Date: 2001/01/10 21:45:05 $
   $Revision: 1.3 $
   $RCSfile: JavaConverter.java $
   $Log: JavaConverter.java $
   Revision 1.3  2001/01/10 21:45:05  dmeline
   First Release

   Revision 1.2  2000/05/05 14:09:26  dmeline
   Comment modification.

   Revision 1.1  2000/05/05 14:02:25  dmeline
   Initial revision

   
   **************************************
   $Id: JavaConverter.java 1.3 2001/01/10 21:45:05 dmeline Exp dmeline $
****************************************************************************/
// Import
// **************************************
// Core
import java.io.*;
import java.util.*;

// Documentation
// **************************************

/**
 * <DL><DT><B>Description</B></DT>
 *  <DD>Convert a text file into another using a properties file.</DD>
 * </DL>
 * <HR WIDTH=25%>
 * <DL>
 *  <DT><B>Public RCS Heading:</B>
 *    <DD>$Id: JavaConverter.java 1.3 2001/01/10 21:45:05 dmeline Exp dmeline $</DD>
 *  </DT>
 * </DL>
 *
 * <DL>
 *  <DT><B>Core Java</B>
 *   <DD> java.io.*</DD>
 *   <DD> java.util.*</DD>
 *  </DT>
 * </DL>
 *
 * <HR WIDTH=10%>
 * @version $Revision: 1.3 $
 * @author $Author: dmeline $
 * @since Jdk 1.2.
 *
 */

// **************************************
public class JavaConverter{
    // Version Control Tag
    private static String VC_NAME = new String("$Name: JavaConverter $");
    private static String VC_DATE = new String("$Date: 2001/01/10 21:45:05 $");
    
    private String fileName;
    private Properties convertionTable;

    /**
     * Constructor : Build a new FileCharacter Converter.
     * @param sourceFileName Text source filename.
     * @param defintionFileName Properties definition filename.
     */
    public JavaConverter(String sourceFileName, String definitionFileName) {
	fileName = sourceFileName;
	convertionTable = new Properties();
	try {
	    java.io.InputStream f = new FileInputStream(definitionFileName);
	    convertionTable.load(f);
	    f.close();
	} catch (Exception e) { }
	
    }
        
    /**
     * Actionner : Convert source file using current definition, and display result.
     */
    public void convert() {
	DataInputStream dis=null;
	int car=0;

	try {
	    dis = new DataInputStream(new FileInputStream(fileName));
	} catch (FileNotFoundException e) { }

	try {
	    while (true)
		System.out.print(convertChar(dis.readUnsignedByte()));
	}
	catch (EOFException e) {
	}
	catch (IOException e) { 
	    System.err.println("Error");
	}

	try {
	    dis.close();
	}
	catch (IOException e) { 
	    System.err.println("Error");
	}
    }

    /**
     * Actionner : Convert source file using current definition file, and write output.
     * @param destinationFileName Destination filename.
     */
    public void convert(String destinationFileName) {
	DataInputStream dis=null;
	DataOutputStream dos=null;
	int car=0;

	try {
	    dis = new DataInputStream(new FileInputStream(fileName));
	} catch (FileNotFoundException e) {
	    System.err.println("Error : FileNorFound " + fileName);
	}

	try {
	    dos = new DataOutputStream(new FileOutputStream(destinationFileName));
	} catch (FileNotFoundException e) { }

	try {
	    while (true)
		dos.writeBytes(convertChar(dis.readUnsignedByte()));
	}
	catch (EOFException e) {
	}
	catch (IOException e) { 
	    System.err.println("Error");
	}

	try {
	    dis.close();
	    dos.flush();
	    dos.close();
	}
	catch (IOException e) { 
	    System.out.println("Error");
	}
    }

    /**
     * Actionner : Convert a character to his new representation using a properties file.
     * @param car Chararater to convert.
     * @return A new String representation of this character.
     */    
    private String convertChar(int car) {
	String converted;
	String toConvert=(new Character((char)car)).toString();

	if ((converted = (String)convertionTable.get(toConvert)) == null )
	    return toConvert;
	else
	    return (String)converted;
    }

    /**
     * Description : Convert a text file into another using a properties file.
     * @param args Command line.
     * <I>Example</I> : java source.txt output.txt html.prop
     * <BR>
     */
    public static void main(String parameters[]) {
	System.out.println(((VC_NAME.substring(7,VC_NAME.length()-1)).replace('_',' ')).replace('-','.'));
	System.out.println((VC_DATE.substring(7,VC_DATE.length()-1)));

	JavaConverter jHtmlc = new JavaConverter(parameters[0],parameters[2]);

	//	System.out.println("Date  : " + new Date().toString());
	//	jHtmlc.convert();
	//	System.out.println("\nDate  : " + new Date().toString());
	jHtmlc.convert(parameters[1]);
	//	System.out.println("Date  : " + new Date().toString());

	System.exit(0);
    }
}
